"use strict";function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter(function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable})),keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach(function(key){_defineProperty(target,key,source[key])}):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach(function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))})}return target}function _defineProperty(obj,key,value){key=_toPropertyKey(key);if(key in obj){Object.defineProperty(obj,key,{value:value,enumerable:true,configurable:true,writable:true})}else{obj[key]=value}return obj}function _toPropertyKey(arg){var key=_toPrimitive(arg,"string");return typeof key==="symbol"?key:String(key)}function _toPrimitive(input,hint){if(typeof input!=="object"||input===null)return input;var prim=input[Symbol.toPrimitive];if(prim!==undefined){var res=prim.call(input,hint||"default");if(typeof res!=="object")return res;throw new TypeError("@@toPrimitive must return a primitive value.")}return(hint==="string"?String:Number)(input)}Object.defineProperty(exports,"__esModule",{value:true});var chalk=require("chalk");var figures=require("figures");var cliCursor=require("cli-cursor");var runAsync=require("run-async");var rxjs=require("rxjs");var defaults=require("lodash/defaults.js");var clone=require("lodash/clone.js");var assert=require("node:assert");var _$2=require("lodash");var ansiEscapes=require("ansi-escapes");var cliWidth=require("cli-width");var wrapAnsi=require("wrap-ansi");var stripAnsi=require("strip-ansi");var stringWidth=require("string-width");var ora=require("ora");var externalEditor=require("external-editor");var through=require("through");var MuteStream=require("mute-stream");var readline=require("node:readline");var isPlainObject=require("lodash/isPlainObject.js");var get=require("lodash/get.js");var set=require("lodash/set.js");/**
 * Separator object
 * Used to space/separate choices group
 * @constructor
 * @param {String} line   Separation line content (facultative)
 */class Separator{constructor(line){this.type="separator";this.line=chalk.dim(line||new Array(15).join(figures.line))}/**
   * Helper function returning false if object is a separator
   * @param  {Object} obj object to test against
   * @return {Boolean}    `false` if object is a separator
   */static exclude(obj){return obj.type!=="separator"}/**
   * Stringify separator
   * @return {String} the separator display string
   */toString(){return this.line}}/**
 * Choice object
 * Normalize input as choice object
 * @constructor
 * @param {Number|String|Object} val  Choice value. If an object is passed, it should contains
 *                                    at least one of `value` or `name` property
 */class Choice{constructor(val,answers){// Don't process Choice and Separator object
if(val instanceof Choice||val.type==="separator"){// eslint-disable-next-line no-constructor-return
return val}if(typeof val==="string"||typeof val==="number"){this.name=String(val);this.value=val;this.short=String(val)}else{Object.assign(this,val,{name:val.name||val.value,value:"value"in val?val.value:val.name,short:val.short||val.name||val.value})}if(typeof val.disabled==="function"){this.disabled=val.disabled(answers)}else{this.disabled=val.disabled}}}/**
 * Choices collection
 * Collection of multiple `choice` object
 */class Choices{/** @param {Array} choices  All `choice` to keep in the collection */constructor(choices,answers){this.choices=choices.map(val=>{if(val.type==="separator"){if(!(val instanceof Separator)){val=new Separator(val.line)}return val}return new Choice(val,answers)});this.realChoices=this.choices.filter(Separator.exclude).filter(item=>!item.disabled);Object.defineProperty(this,"length",{get(){return this.choices.length},set(val){this.choices.length=val}});Object.defineProperty(this,"realLength",{get(){return this.realChoices.length},set(){throw new Error("Cannot set `realLength` of a Choices collection")}})}/**
   * Get a valid choice from the collection
   * @param  {Number} selector  The selected choice index
   * @return {Choice|Undefined} Return the matched choice or undefined
   */getChoice(selector){assert(typeof selector==="number");return this.realChoices[selector]}/**
   * Get a raw element from the collection
   * @param  {Number} selector  The selected index value
   * @return {Choice|Undefined} Return the matched choice or undefined
   */get(selector){assert(typeof selector==="number");return this.choices[selector]}/**
   * Match the valid choices against a where clause
   * @param  {Object} whereClause Lodash `where` clause
   * @return {Array}              Matching choices or empty array
   */where(whereClause){return _$2.filter(this.realChoices,whereClause)}/**
   * Pluck a particular key from the choices
   * @param  {String} propertyName Property name to select
   * @return {Array}               Selected properties
   */pluck(propertyName){return _$2.map(this.realChoices,propertyName)}// Expose usual Array methods
indexOf(...args){return this.choices.indexOf(...args)}forEach(...args){return this.choices.forEach(...args)}filter(...args){return this.choices.filter(...args)}reduce(...args){return this.choices.reduce(...args)}find(func){return this.choices.find(func)}push(...args){const objs=args.map(val=>new Choice(val));this.choices.push(...objs);this.realChoices=this.choices.filter(Separator.exclude).filter(item=>!item.disabled);return this.choices}}/**
 * Move cursor left by `x`
 * @param  {Readline} rl - Readline instance
 * @param  {Number}   x  - How far to go left (default to 1)
 */const left=function(rl,x){rl.output.write(ansiEscapes.cursorBackward(x))};/**
 * Move cursor right by `x`
 * @param  {Readline} rl - Readline instance
 * @param  {Number}   x  - How far to go left (default to 1)
 */const right=function(rl,x){rl.output.write(ansiEscapes.cursorForward(x))};/**
 * Move cursor up by `x`
 * @param  {Readline} rl - Readline instance
 * @param  {Number}   x  - How far to go up (default to 1)
 */const up=function(rl,x){rl.output.write(ansiEscapes.cursorUp(x))};/**
 * Move cursor down by `x`
 * @param  {Readline} rl - Readline instance
 * @param  {Number}   x  - How far to go down (default to 1)
 */const down=function(rl,x){rl.output.write(ansiEscapes.cursorDown(x))};/**
 * Clear current line
 * @param  {Readline} rl  - Readline instance
 * @param  {Number}   len - number of line to delete
 */const clearLine=function(rl,len){rl.output.write(ansiEscapes.eraseLines(len))};function height(content){return content.split("\n").length}/** @param {string} content */function lastLine(content){return content.split("\n").pop()}class ScreenManager{constructor(rl){// These variables are keeping information to allow correct prompt re-rendering
this.height=0;this.extraLinesUnderPrompt=0;this.rl=rl}renderWithSpinner(content,bottomContent){if(this.spinnerId){clearInterval(this.spinnerId)}let spinner;let contentFunc;let bottomContentFunc;if(bottomContent){spinner=ora(bottomContent);contentFunc=()=>content;bottomContentFunc=()=>spinner.frame()}else{spinner=ora(content);contentFunc=()=>spinner.frame();bottomContentFunc=()=>""}this.spinnerId=setInterval(()=>this.render(contentFunc(),bottomContentFunc(),true),spinner.interval)}render(content,bottomContent,spinning=false){if(this.spinnerId&&!spinning){clearInterval(this.spinnerId)}this.rl.output.unmute();this.clean(this.extraLinesUnderPrompt);/**
     * Write message to screen and setPrompt to control backspace
     */const promptLine=lastLine(content);const rawPromptLine=stripAnsi(promptLine);// Remove the rl.line from our prompt. We can't rely on the content of
// rl.line (mainly because of the password prompt), so just rely on it's
// length.
let prompt=rawPromptLine;if(this.rl.line.length){prompt=prompt.slice(0,-this.rl.line.length)}this.rl.setPrompt(prompt);// SetPrompt will change cursor position, now we can get correct value
const cursorPos=this.rl._getCursorPos();const width=this.normalizedCliWidth();content=this.forceLineReturn(content,width);if(bottomContent){bottomContent=this.forceLineReturn(bottomContent,width)}// Manually insert an extra line if we're at the end of the line.
// This prevent the cursor from appearing at the beginning of the
// current line.
if(rawPromptLine.length%width===0){content+="\n"}const fullContent=content+(bottomContent?"\n"+bottomContent:"");this.rl.output.write(fullContent);/**
     * Re-adjust the cursor at the correct position.
     */ // We need to consider parts of the prompt under the cursor as part of the bottom
// content in order to correctly cleanup and re-render.
const promptLineUpDiff=Math.floor(rawPromptLine.length/width)-cursorPos.rows;const bottomContentHeight=promptLineUpDiff+(bottomContent?height(bottomContent):0);if(bottomContentHeight>0){up(this.rl,bottomContentHeight)}// Reset cursor at the beginning of the line
left(this.rl,stringWidth(lastLine(fullContent)));// Adjust cursor on the right
if(cursorPos.cols>0){right(this.rl,cursorPos.cols)}/**
     * Set up state for next re-rendering
     */this.extraLinesUnderPrompt=bottomContentHeight;this.height=height(fullContent);this.rl.output.mute()}clean(extraLines){if(extraLines>0){down(this.rl,extraLines)}clearLine(this.rl,this.height)}done(){this.rl.setPrompt("");this.rl.output.unmute();this.rl.output.write("\n")}releaseCursor(){if(this.extraLinesUnderPrompt>0){down(this.rl,this.extraLinesUnderPrompt)}}normalizedCliWidth(){const width=cliWidth({defaultWidth:80,output:this.rl.output});return width}/**
   * @param {string[]} lines
   */breakLines(lines,width=this.normalizedCliWidth()){// Break lines who're longer than the cli width so we can normalize the natural line
// returns behavior across terminals.
// re: trim: false; by default, `wrap-ansi` trims whitespace, which
// is not what we want.
// re: hard: true; by default', `wrap-ansi` does soft wrapping
return lines.map(line=>wrapAnsi(line,width,{trim:false,hard:true}).split("\n"))}/**
   * @param {string} content
   */forceLineReturn(content,width=this.normalizedCliWidth()){return this.breakLines(content.split("\n"),width).flat().join("\n")}}/**
 * Base prompt implementation
 * Should be extended by prompt types.
 */const _$1={defaults,clone};class Prompt{constructor(question,rl,answers){// Setup instance defaults property
Object.assign(this,{answers,status:"pending"});// Set defaults prompt options
this.opt=_$1.defaults(_$1.clone(question),{validate:()=>true,validatingText:"",filter:val=>val,filteringText:"",when:()=>true,suffix:"",prefix:chalk.green("?"),transformer:val=>val});// Make sure name is present
if(!this.opt.name){this.throwParamError("name")}// Set default message if no message defined
if(!this.opt.message){this.opt.message=this.opt.name+":"}// Normalize choices
if(Array.isArray(this.opt.choices)){this.opt.choices=new Choices(this.opt.choices,answers)}this.rl=rl;this.screen=new ScreenManager(this.rl)}/**
   * Start the Inquiry session and manage output value filtering
   * @return {Promise}
   */run(){return new Promise((resolve,reject)=>{this._run(value=>resolve(value),error=>reject(error))})}// Default noop (this one should be overwritten in prompts)
_run(cb){cb()}/**
   * Throw an error telling a required parameter is missing
   * @param  {String} name Name of the missing param
   * @return {Throw Error}
   */throwParamError(name){throw new Error("You must provide a `"+name+"` parameter")}/**
   * Called when the UI closes. Override to do any specific cleanup necessary
   */close(){this.screen.releaseCursor()}/**
   * Run the provided validation method each time a submit event occur.
   * @param  {Rx.Observable} submit - submit event flow
   * @return {Object}        Object containing two observables: `success` and `error`
   */handleSubmitEvents(submit){const self=this;const validate=runAsync(this.opt.validate);const asyncFilter=runAsync(this.opt.filter);const validation=submit.pipe(rxjs.flatMap(value=>{this.startSpinner(value,this.opt.filteringText);return asyncFilter(value,self.answers).then(filteredValue=>{this.startSpinner(filteredValue,this.opt.validatingText);return validate(filteredValue,self.answers).then(isValid=>({isValid,value:filteredValue}),err=>({isValid:err,value:filteredValue}))},err=>({isValid:err}))}),rxjs.share());const success=validation.pipe(rxjs.filter(state=>state.isValid===true),rxjs.take(1));const error=validation.pipe(rxjs.filter(state=>state.isValid!==true),rxjs.takeUntil(success));return{success,error}}startSpinner(value,bottomContent){value=this.getSpinningValue(value);// If the question will spin, cut off the prefix (for layout purposes)
const content=bottomContent?this.getQuestion()+value:this.getQuestion().slice(this.opt.prefix.length+1)+value;this.screen.renderWithSpinner(content,bottomContent)}/**
   * Allow override, e.g. for password prompts
   * See: https://github.com/SBoudrias/Inquirer.js/issues/1022
   *
   * @return {String} value to display while spinning
   */getSpinningValue(value){return value}/**
   * Generate the prompt question string
   * @return {String} prompt question string
   */getQuestion(){let message=(this.opt.prefix?this.opt.prefix+" ":"")+chalk.bold(this.opt.message)+this.opt.suffix+chalk.reset(" ");// Append the default if available, and if question isn't touched/answered
if(this.opt.default!=null&&this.status!=="touched"&&this.status!=="answered"){// If default password is supplied, hide it
if(this.opt.type==="password"){message+=chalk.italic.dim("[hidden] ")}else{message+=chalk.dim("("+this.opt.default+") ")}}return message}}function normalizeKeypressEvents(value,key){return{value,key:key||{}}}function observe(rl){const keypress=rxjs.fromEvent(rl.input,"keypress",normalizeKeypressEvents).pipe(rxjs.takeUntil(rxjs.fromEvent(rl,"close")))// Ignore `enter` key. On the readline, we only care about the `line` event.
.pipe(rxjs.filter(({key})=>key.name!=="enter"&&key.name!=="return"));return{line:rxjs.fromEvent(rl,"line"),keypress,normalizedUpKey:keypress.pipe(rxjs.filter(({key})=>key.name==="up"||key.name==="k"||key.name==="p"&&key.ctrl),rxjs.share()),normalizedDownKey:keypress.pipe(rxjs.filter(({key})=>key.name==="down"||key.name==="j"||key.name==="n"&&key.ctrl),rxjs.share()),numberKey:keypress.pipe(rxjs.filter(e=>e.value&&"123456789".indexOf(e.value)>=0),rxjs.map(e=>Number(e.value)),rxjs.share()),spaceKey:keypress.pipe(rxjs.filter(({key})=>key&&key.name==="space"),rxjs.share()),aKey:keypress.pipe(rxjs.filter(({key})=>key&&key.name==="a"),rxjs.share()),iKey:keypress.pipe(rxjs.filter(({key})=>key&&key.name==="i"),rxjs.share())}}/**
 * The paginator returns a subset of the choices if the list is too long.
 */class Paginator{/**
   * @param {import("./screen-manager")} [screen]
   * @param {{isInfinite?: boolean}} [options]
   */constructor(screen,options={}){const{isInfinite=true}=options;this.lastIndex=0;this.screen=screen;this.isInfinite=isInfinite}paginate(output,active,pageSize){pageSize=pageSize||7;let lines=output.split("\n");if(this.screen){lines=this.screen.breakLines(lines);active=lines.map(lineParts=>lineParts.length).splice(0,active).reduce((a,b)=>a+b,0);lines=lines.flat()}// Make sure there's enough lines to paginate
if(lines.length<=pageSize){return output}const visibleLines=this.isInfinite?this.getInfiniteLines(lines,active,pageSize):this.getFiniteLines(lines,active,pageSize);this.lastIndex=active;return visibleLines.join("\n")+"\n"+chalk.dim("(Move up and down to reveal more choices)")}getInfiniteLines(lines,active,pageSize){if(this.pointer===undefined){this.pointer=0}const middleOfList=Math.floor(pageSize/2);// Move the pointer only when the user go down and limit it to the middle of the list
if(this.pointer<middleOfList&&this.lastIndex<active&&active-this.lastIndex<pageSize){this.pointer=Math.min(middleOfList,this.pointer+active-this.lastIndex)}// Duplicate the lines so it give an infinite list look
const infinite=[lines,lines,lines].flat();const topIndex=Math.max(0,active+lines.length-this.pointer);return infinite.splice(topIndex,pageSize)}getFiniteLines(lines,active,pageSize){let topIndex=active-pageSize/2;if(topIndex<0){topIndex=0}else if(topIndex+pageSize>lines.length){topIndex=lines.length-pageSize}return lines.splice(topIndex,pageSize)}}function incrementListIndex(current,dir,opt){const len=opt.choices.realLength;const shouldLoop="loop"in opt?Boolean(opt.loop):true;if(dir==="up"){if(current>0){return current-1}return shouldLoop?len-1:current}if(dir==="down"){if(current<len-1){return current+1}return shouldLoop?0:current}throw new Error("dir must be up or down")}/**
 * `list` type prompt
 */class ListPrompt extends Prompt{constructor(questions,rl,answers){super(questions,rl,answers);if(!this.opt.choices){this.throwParamError("choices")}this.firstRender=true;this.selected=0;const def=this.opt.default;// If def is a Number, then use as index. Otherwise, check for value.
if(typeof def==="number"&&def>=0&&def<this.opt.choices.realLength){this.selected=def}else if(typeof def!=="number"&&def!=null){const index=this.opt.choices.realChoices.findIndex(({value})=>value===def);this.selected=Math.max(index,0)}// Make sure no default is set (so it won't be printed)
this.opt.default=null;const shouldLoop=this.opt.loop===undefined?true:this.opt.loop;this.paginator=new Paginator(this.screen,{isInfinite:shouldLoop})}/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;const self=this;const events=observe(this.rl);events.normalizedUpKey.pipe(rxjs.takeUntil(events.line)).forEach(this.onUpKey.bind(this));events.normalizedDownKey.pipe(rxjs.takeUntil(events.line)).forEach(this.onDownKey.bind(this));events.numberKey.pipe(rxjs.takeUntil(events.line)).forEach(this.onNumberKey.bind(this));events.line.pipe(rxjs.take(1),rxjs.map(this.getCurrentValue.bind(this)),rxjs.flatMap(value=>runAsync(self.opt.filter)(value,self.answers).catch(err=>err))).forEach(this.onSubmit.bind(this));// Init the prompt
cliCursor.hide();this.render();return this}/**
   * Render the prompt to screen
   * @return {ListPrompt} self
   */render(){// Render question
let message=this.getQuestion();if(this.firstRender){message+=chalk.dim("(Use arrow keys)")}// Render choices or answer depending on the state
if(this.status==="answered"){message+=chalk.cyan(this.opt.choices.getChoice(this.selected).short)}else{const choicesStr=listRender(this.opt.choices,this.selected);const indexPosition=this.opt.choices.indexOf(this.opt.choices.getChoice(this.selected));const realIndexPosition=this.opt.choices.reduce((acc,value,i)=>{// Dont count lines past the choice we are looking at
if(i>indexPosition){return acc}// Add line if it's a separator
if(value.type==="separator"){return acc+1}let l=value.name;// Non-strings take up one line
if(typeof l!=="string"){return acc+1}// Calculate lines taken up by string
l=l.split("\n");return acc+l.length},0)-1;message+="\n"+this.paginator.paginate(choicesStr,realIndexPosition,this.opt.pageSize)}this.firstRender=false;this.screen.render(message)}/**
   * When user press `enter` key
   */onSubmit(value){this.status="answered";// Rerender prompt
this.render();this.screen.done();cliCursor.show();this.done(value)}getCurrentValue(){return this.opt.choices.getChoice(this.selected).value}/**
   * When user press a key
   */onUpKey(){this.selected=incrementListIndex(this.selected,"up",this.opt);this.render()}onDownKey(){this.selected=incrementListIndex(this.selected,"down",this.opt);this.render()}onNumberKey(input){if(input<=this.opt.choices.realLength){this.selected=input-1}this.render()}}/**
 * Function for rendering list choices
 * @param  {Number} pointer Position of the pointer
 * @return {String}         Rendered content
 */function listRender(choices,pointer){let output="";let separatorOffset=0;choices.forEach((choice,i)=>{if(choice.type==="separator"){separatorOffset++;output+="  "+choice+"\n";return}if(choice.disabled){separatorOffset++;output+="  - "+choice.name;output+=` (${typeof choice.disabled==="string"?choice.disabled:"Disabled"})`;output+="\n";return}const isSelected=i-separatorOffset===pointer;let line=(isSelected?figures.pointer+" ":"  ")+choice.name;if(isSelected){line=chalk.cyan(line)}output+=line+" \n"});return output.replace(/\n$/,"")}/**
 * `input` type prompt
 */class InputPrompt extends Prompt{/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;// Once user confirm (enter key)
const events=observe(this.rl);const submit=events.line.pipe(rxjs.map(this.filterInput.bind(this)));const validation=this.handleSubmitEvents(submit);validation.success.forEach(this.onEnd.bind(this));validation.error.forEach(this.onError.bind(this));events.keypress.pipe(rxjs.takeUntil(validation.success)).forEach(this.onKeypress.bind(this));// Init
this.render();return this}/**
   * Render the prompt to screen
   * @return {InputPrompt} self
   */render(error){let bottomContent="";let appendContent="";let message=this.getQuestion();const{transformer}=this.opt;const isFinal=this.status==="answered";if(isFinal){appendContent=this.answer}else{appendContent=this.rl.line}if(transformer){message+=transformer(appendContent,this.answers,{isFinal})}else{message+=isFinal?chalk.cyan(appendContent):appendContent}if(error){bottomContent=chalk.red(">> ")+error}this.screen.render(message,bottomContent)}/**
   * When user press `enter` key
   */filterInput(input){if(!input){return this.opt.default==null?"":this.opt.default}return input}onEnd(state){this.answer=state.value;this.status="answered";// Re-render prompt
this.render();this.screen.done();this.done(state.value)}onError({value="",isValid}){this.rl.line+=value;this.rl.cursor+=value.length;this.render(isValid)}/**
   * When user press a key
   */onKeypress(){this.status="touched";this.render()}}/**
 * `input` type prompt
 */ /**
 * Extention of the Input prompt specifically for use with number inputs.
 */class NumberPrompt extends InputPrompt{filterInput(input){if(input&&typeof input==="string"){input=input.trim();// Match a number in the input
const numberMatch=input.match(/(^-?\d+|^-?\d+\.\d*|^\d*\.\d+)(e\d+)?$/);// If a number is found, return that input.
if(numberMatch){return Number(numberMatch[0])}}// If the input was invalid return the default value.
return this.opt.default==null?NaN:this.opt.default}}/**
 * `confirm` type prompt
 */class ConfirmPrompt extends Prompt{constructor(questions,rl,answers){super(questions,rl,answers);let rawDefault=true;Object.assign(this.opt,{filter(input){let value=rawDefault;if(input!=null&&input!==""){value=/^y(es)?/i.test(input)}return value}});if(this.opt.default!=null){rawDefault=Boolean(this.opt.default)}this.opt.default=rawDefault?"Y/n":"y/N"}/**
   * Start the Inquiry session
   * @param  {Function} cb   Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;// Once user confirm (enter key)
const events=observe(this.rl);events.keypress.pipe(rxjs.takeUntil(events.line)).forEach(this.onKeypress.bind(this));events.line.pipe(rxjs.take(1)).forEach(this.onEnd.bind(this));// Init
this.render();return this}/**
   * Render the prompt to screen
   * @return {ConfirmPrompt} self
   */render(answer){let message=this.getQuestion();if(typeof answer==="boolean"){message+=chalk.cyan(answer?"Yes":"No")}else if(answer){message+=answer}else{message+=this.rl.line}this.screen.render(message);return this}/**
   * When user press `enter` key
   */onEnd(input){this.status="answered";let output=this.opt.filter(input);if(this.opt.transformer){output=this.opt.transformer(output)}this.render(output);this.screen.done();this.done(output)}/**
   * When user press a key
   */onKeypress(){this.render()}}/**
 * `rawlist` type prompt
 */class RawListPrompt extends Prompt{constructor(questions,rl,answers){super(questions,rl,answers);this.hiddenLine="";this.lastKey="";if(!this.opt.choices){this.throwParamError("choices")}this.opt.validChoices=this.opt.choices.filter(Separator.exclude);this.selected=0;this.rawDefault=0;Object.assign(this.opt,{validate(val){return val!=null}});const def=this.opt.default;if(typeof def==="number"&&def>=0&&def<this.opt.choices.realLength){this.selected=def;this.rawDefault=def}else if(typeof def!=="number"&&def!=null){const index=this.opt.choices.realChoices.findIndex(({value})=>value===def);const safeIndex=Math.max(index,0);this.selected=safeIndex;this.rawDefault=safeIndex}// Make sure no default is set (so it won't be printed)
this.opt.default=null;const shouldLoop=this.opt.loop===undefined?true:this.opt.loop;this.paginator=new Paginator(undefined,{isInfinite:shouldLoop})}/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;// Once user confirm (enter key)
const events=observe(this.rl);const submit=events.line.pipe(rxjs.map(this.getCurrentValue.bind(this)));const validation=this.handleSubmitEvents(submit);validation.success.forEach(this.onEnd.bind(this));validation.error.forEach(this.onError.bind(this));events.normalizedUpKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onUpKey.bind(this));events.normalizedDownKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onDownKey.bind(this));events.keypress.pipe(rxjs.takeUntil(validation.success)).forEach(this.onKeypress.bind(this));// Init the prompt
this.render();return this}/**
   * Render the prompt to screen
   * @return {RawListPrompt} self
   */render(error){// Render question
let message=this.getQuestion();let bottomContent="";if(this.status==="answered"){message+=chalk.cyan(this.opt.choices.getChoice(this.selected).short)}else{const choicesStr=renderChoices$2(this.opt.choices,this.selected);message+="\n"+this.paginator.paginate(choicesStr,this.selected,this.opt.pageSize);message+="\n  Answer: "}message+=this.rl.line;if(error){bottomContent="\n"+chalk.red(">> ")+error}this.screen.render(message,bottomContent)}/**
   * When user press `enter` key
   */getCurrentValue(index){if(index==null){index=this.rawDefault}else if(index===""){this.selected=this.selected===undefined?-1:this.selected;index=this.selected}else{index-=1}const choice=this.opt.choices.getChoice(index);return choice?choice.value:null}onEnd(state){this.status="answered";this.answer=state.value;// Re-render prompt
this.render();this.screen.done();this.done(state.value)}onError(){this.render("Please enter a valid index")}/**
   * When user press a key
   */onKeypress(){let index;if(this.lastKey==="arrow"){index=this.hiddenLine.length?Number(this.hiddenLine)-1:0}else{index=this.rl.line.length?Number(this.rl.line)-1:0}this.lastKey="";if(this.opt.choices.getChoice(index)){this.selected=index}else{this.selected=undefined}this.render()}/**
   * When user press up key
   */onUpKey(){this.onArrowKey("up")}/**
   * When user press down key
   */onDownKey(){this.onArrowKey("down")}/**
   * When user press up or down key
   * @param {String} type Arrow type: up or down
   */onArrowKey(type){this.selected=incrementListIndex(this.selected,type,this.opt)||0;this.hiddenLine=String(this.selected+1);this.rl.line="";this.lastKey="arrow"}}/**
 * Function for rendering list choices
 * @param  {Number} pointer Position of the pointer
 * @return {String}         Rendered content
 */function renderChoices$2(choices,pointer){let output="";let separatorOffset=0;choices.forEach((choice,i)=>{output+=output?"\n  ":"  ";if(choice.type==="separator"){separatorOffset++;output+=" "+choice;return}const index=i-separatorOffset;let display=index+1+") "+choice.name;if(index===pointer){display=chalk.cyan(display)}output+=display});return output}/**
 * `rawlist` type prompt
 */class ExpandPrompt extends Prompt{constructor(questions,rl,answers){super(questions,rl,answers);if(!this.opt.choices){this.throwParamError("choices")}this.validateChoices(this.opt.choices);// Add the default `help` (/expand) option
this.opt.choices.push({key:"h",name:"Help, list all options",value:"help"});this.opt.validate=choice=>{if(choice==null){return"Please enter a valid command"}return choice!=="help"};// Setup the default string (capitalize the default key)
this.opt.default=this.generateChoicesString(this.opt.choices,this.opt.default);this.paginator=new Paginator(this.screen)}/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;// Save user answer and update prompt to show selected option.
const events=observe(this.rl);const validation=this.handleSubmitEvents(events.line.pipe(rxjs.map(this.getCurrentValue.bind(this))));validation.success.forEach(this.onSubmit.bind(this));validation.error.forEach(this.onError.bind(this));this.keypressObs=events.keypress.pipe(rxjs.takeUntil(validation.success)).forEach(this.onKeypress.bind(this));// Init the prompt
this.render();return this}/**
   * Render the prompt to screen
   * @return {ExpandPrompt} self
   */render(error,hint){let message=this.getQuestion();let bottomContent="";if(this.status==="answered"){message+=chalk.cyan(this.answer)}else if(this.status==="expanded"){const choicesStr=renderChoices$1(this.opt.choices,this.selectedKey);message+=this.paginator.paginate(choicesStr,this.selectedKey,this.opt.pageSize);message+="\n  Answer: "}message+=this.rl.line;if(error){bottomContent=chalk.red(">> ")+error}if(hint){bottomContent=chalk.cyan(">> ")+hint}this.screen.render(message,bottomContent)}getCurrentValue(input){if(!input){input=this.rawDefault}const selected=this.opt.choices.where({key:input.toLowerCase().trim()})[0];if(!selected){return null}return selected.value}/**
   * Generate the prompt choices string
   * @return {String}  Choices string
   */getChoices(){let output="";this.opt.choices.forEach(choice=>{output+="\n  ";if(choice.type==="separator"){output+=" "+choice;return}let choiceStr=choice.key+") "+choice.name;if(this.selectedKey===choice.key){choiceStr=chalk.cyan(choiceStr)}output+=choiceStr});return output}onError(state){if(state.value==="help"){this.selectedKey="";this.status="expanded";this.render();return}this.render(state.isValid)}/**
   * When user press `enter` key
   */onSubmit(state){this.status="answered";const choice=this.opt.choices.where({value:state.value})[0];this.answer=choice.short||choice.name;// Re-render prompt
this.render();this.screen.done();this.done(state.value)}/**
   * When user press a key
   */onKeypress(){this.selectedKey=this.rl.line.toLowerCase();const selected=this.opt.choices.where({key:this.selectedKey})[0];if(this.status==="expanded"){this.render()}else{this.render(null,selected?selected.name:null)}}/**
   * Validate the choices
   * @param {Array} choices
   */validateChoices(choices){let formatError;const errors=[];const keymap={};choices.filter(Separator.exclude).forEach(choice=>{if(!choice.key||choice.key.length!==1){formatError=true}choice.key=String(choice.key).toLowerCase();if(keymap[choice.key]){errors.push(choice.key)}keymap[choice.key]=true});if(formatError){throw new Error("Format error: `key` param must be a single letter and is required.")}if(keymap.h){throw new Error("Reserved key error: `key` param cannot be `h` - this value is reserved.")}if(errors.length){throw new Error("Duplicate key error: `key` param must be unique. Duplicates: "+[...new Set(errors)].join(","))}}/**
   * Generate a string out of the choices keys
   * @param  {Array}  choices
   * @param  {Number|String} default - the choice index or name to capitalize
   * @return {String} The rendered choices key string
   */generateChoicesString(choices,defaultChoice){let defIndex=choices.realLength-1;if(typeof defaultChoice==="number"&&this.opt.choices.getChoice(defaultChoice)){defIndex=defaultChoice}else if(typeof defaultChoice==="string"){const index=choices.realChoices.findIndex(({value})=>value===defaultChoice);defIndex=index===-1?defIndex:index}const defStr=this.opt.choices.pluck("key");this.rawDefault=defStr[defIndex];defStr[defIndex]=String(defStr[defIndex]).toUpperCase();return defStr.join("")}}/**
 * Function for rendering checkbox choices
 * @param  {String} pointer Selected key
 * @return {String}         Rendered content
 */function renderChoices$1(choices,pointer){let output="";choices.forEach(choice=>{output+="\n  ";if(choice.type==="separator"){output+=" "+choice;return}let choiceStr=choice.key+") "+choice.name;if(pointer===choice.key){choiceStr=chalk.cyan(choiceStr)}output+=choiceStr});return output}/**
 * `list` type prompt
 */class CheckboxPrompt extends Prompt{constructor(questions,rl,answers){super(questions,rl,answers);if(!this.opt.choices){this.throwParamError("choices")}if(Array.isArray(this.opt.default)){this.opt.choices.forEach(function(choice){if(this.opt.default.indexOf(choice.value)>=0){choice.checked=true}},this)}this.pointer=0;// Make sure no default is set (so it won't be printed)
this.opt.default=null;const shouldLoop=this.opt.loop===undefined?true:this.opt.loop;this.paginator=new Paginator(this.screen,{isInfinite:shouldLoop})}/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;const events=observe(this.rl);const validation=this.handleSubmitEvents(events.line.pipe(rxjs.map(this.getCurrentValue.bind(this))));validation.success.forEach(this.onEnd.bind(this));validation.error.forEach(this.onError.bind(this));events.normalizedUpKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onUpKey.bind(this));events.normalizedDownKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onDownKey.bind(this));events.numberKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onNumberKey.bind(this));events.spaceKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onSpaceKey.bind(this));events.aKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onAllKey.bind(this));events.iKey.pipe(rxjs.takeUntil(validation.success)).forEach(this.onInverseKey.bind(this));// Init the prompt
cliCursor.hide();this.render();this.firstRender=false;return this}/**
   * Render the prompt to screen
   * @return {CheckboxPrompt} self
   */render(error){// Render question
let message=this.getQuestion();let bottomContent="";if(!this.dontShowHints){message+="(Press "+chalk.cyan.bold("<space>")+" to select, "+chalk.cyan.bold("<a>")+" to toggle all, "+chalk.cyan.bold("<i>")+" to invert selection, and "+chalk.cyan.bold("<enter>")+" to proceed)"}// Render choices or answer depending on the state
if(this.status==="answered"){message+=chalk.cyan(this.selection.join(", "))}else{const choicesStr=renderChoices(this.opt.choices,this.pointer);const indexPosition=this.opt.choices.indexOf(this.opt.choices.getChoice(this.pointer));const realIndexPosition=this.opt.choices.reduce((acc,value,i)=>{// Dont count lines past the choice we are looking at
if(i>indexPosition){return acc}// Add line if it's a separator
if(value.type==="separator"){return acc+1}let l=value.name;// Non-strings take up one line
if(typeof l!=="string"){return acc+1}// Calculate lines taken up by string
l=l.split("\n");return acc+l.length},0)-1;message+="\n"+this.paginator.paginate(choicesStr,realIndexPosition,this.opt.pageSize)}if(error){bottomContent=chalk.red(">> ")+error}this.screen.render(message,bottomContent)}/**
   * When user press `enter` key
   */onEnd(state){this.status="answered";this.dontShowHints=true;// Rerender prompt (and clean subline error)
this.render();this.screen.done();cliCursor.show();this.done(state.value)}onError(state){this.render(state.isValid)}getCurrentValue(){const choices=this.opt.choices.filter(choice=>Boolean(choice.checked)&&!choice.disabled);this.selection=choices.map(choice=>choice.short);return choices.map(choice=>choice.value)}onUpKey(){this.pointer=incrementListIndex(this.pointer,"up",this.opt);this.render()}onDownKey(){this.pointer=incrementListIndex(this.pointer,"down",this.opt);this.render()}onNumberKey(input){if(input<=this.opt.choices.realLength){this.pointer=input-1;this.toggleChoice(this.pointer)}this.render()}onSpaceKey(){this.toggleChoice(this.pointer);this.render()}onAllKey(){const shouldBeChecked=Boolean(this.opt.choices.find(choice=>choice.type!=="separator"&&!choice.checked));this.opt.choices.forEach(choice=>{if(choice.type!=="separator"){choice.checked=shouldBeChecked}});this.render()}onInverseKey(){this.opt.choices.forEach(choice=>{if(choice.type!=="separator"){choice.checked=!choice.checked}});this.render()}toggleChoice(index){const item=this.opt.choices.getChoice(index);if(item!==undefined){this.opt.choices.getChoice(index).checked=!item.checked}}}/**
 * Function for rendering checkbox choices
 * @param  {Number} pointer Position of the pointer
 * @return {String}         Rendered content
 */function renderChoices(choices,pointer){let output="";let separatorOffset=0;choices.forEach((choice,i)=>{if(choice.type==="separator"){separatorOffset++;output+=" "+choice+"\n";return}if(choice.disabled){separatorOffset++;output+=" - "+choice.name;output+=` (${typeof choice.disabled==="string"?choice.disabled:"Disabled"})`}else{const line=getCheckbox(choice.checked)+" "+choice.name;if(i-separatorOffset===pointer){output+=chalk.cyan(figures.pointer+line)}else{output+=" "+line}}output+="\n"});return output.replace(/\n$/,"")}/**
 * Get the checkbox
 * @param  {Boolean} checked - add a X or not to the checkbox
 * @return {String} Composited checkbox string
 */function getCheckbox(checked){return checked?chalk.green(figures.radioOn):figures.radioOff}/**
 * `password` type prompt
 */function mask(input,maskChar){input=String(input);maskChar=typeof maskChar==="string"?maskChar:"*";if(input.length===0){return""}return new Array(input.length+1).join(maskChar)}class PasswordPrompt extends Prompt{/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;const events=observe(this.rl);// Once user confirm (enter key)
const submit=events.line.pipe(rxjs.map(this.filterInput.bind(this)));const validation=this.handleSubmitEvents(submit);validation.success.forEach(this.onEnd.bind(this));validation.error.forEach(this.onError.bind(this));events.keypress.pipe(rxjs.takeUntil(validation.success)).forEach(this.onKeypress.bind(this));// Init
this.render();return this}/**
   * Render the prompt to screen
   * @return {PasswordPrompt} self
   */render(error){let message=this.getQuestion();let bottomContent="";if(this.status==="answered"){message+=this.getMaskedValue(this.answer)}else{message+=this.getMaskedValue(this.rl.line||"")}if(error){bottomContent="\n"+chalk.red(">> ")+error}this.screen.render(message,bottomContent)}getMaskedValue(value){if(this.status==="answered"){return this.opt.mask?chalk.cyan(mask(value,this.opt.mask)):chalk.italic.dim("[hidden]")}return this.opt.mask?mask(value,this.opt.mask):chalk.italic.dim("[input is hidden] ")}/**
   * Mask value during async filter/validation.
   */getSpinningValue(value){return this.getMaskedValue(value)}/**
   * When user press `enter` key
   */filterInput(input){if(!input){return this.opt.default==null?"":this.opt.default}return input}onEnd(state){this.status="answered";this.answer=state.value;// Re-render prompt
this.render();this.screen.done();this.done(state.value)}onError(state){this.render(state.isValid)}onKeypress(){// If user press a key, just clear the default value
if(this.opt.default){this.opt.default=undefined}this.render()}}/**
 * `editor` type prompt
 */class EditorPrompt extends Prompt{/**
   * Start the Inquiry session
   * @param  {Function} cb      Callback when prompt is done
   * @return {this}
   */_run(cb){this.done=cb;this.editorResult=new rxjs.Subject;// Open Editor on "line" (Enter Key)
const events=observe(this.rl);this.lineSubscription=events.line.subscribe(this.startExternalEditor.bind(this));const waitUserInput=this.opt.waitUserInput===undefined?true:this.opt.waitUserInput;if(!waitUserInput){this.startExternalEditor()}// Trigger Validation when editor closes
const validation=this.handleSubmitEvents(this.editorResult);validation.success.forEach(this.onEnd.bind(this));validation.error.forEach(this.onError.bind(this));// Prevents default from being printed on screen (can look weird with multiple lines)
this.currentText=this.opt.default;this.opt.default=null;// Init
this.render();return this}/**
   * Render the prompt to screen
   * @return {EditorPrompt} self
   */render(error){let bottomContent="";let message=this.getQuestion();if(this.status==="answered"){message+=chalk.dim("Received")}else{message+=chalk.dim("Press <enter> to launch your preferred editor.")}if(error){bottomContent=chalk.red(">> ")+error}this.screen.render(message,bottomContent)}/**
   * Launch $EDITOR on user press enter
   */startExternalEditor(){var _this$opt$postfix;// Pause Readline to prevent stdin and stdout from being modified while the editor is showing
this.rl.pause();externalEditor.editAsync(this.currentText,this.endExternalEditor.bind(this),{postfix:(_this$opt$postfix=this.opt.postfix)!==null&&_this$opt$postfix!==void 0?_this$opt$postfix:".txt"})}endExternalEditor(error,result){this.rl.resume();if(error){this.editorResult.error(error)}else{this.editorResult.next(result)}}onEnd(state){this.editorResult.unsubscribe();this.lineSubscription.unsubscribe();this.answer=state.value;this.status="answered";// Re-render prompt
this.render();this.screen.done();this.done(this.answer)}onError(state){this.render(state.isValid)}}/**
 * Base interface class other can inherits from
 */class UI{constructor(opt){// Instantiate the Readline interface
// @Note: Don't reassign if already present (allow test to override the Stream)
if(!this.rl){this.rl=readline.createInterface(setupReadlineOptions(opt))}this.rl.resume();this.onForceClose=this.onForceClose.bind(this);// Make sure new prompt start on a newline when closing
process.on("exit",this.onForceClose);// Terminate process on SIGINT (which will call process.on('exit') in return)
this.rl.on("SIGINT",this.onForceClose)}/**
   * Handle the ^C exit
   * @return {null}
   */onForceClose(){this.close();process.kill(process.pid,"SIGINT");console.log("")}/**
   * Close the interface and cleanup listeners
   */close(){// Remove events listeners
this.rl.removeListener("SIGINT",this.onForceClose);process.removeListener("exit",this.onForceClose);this.rl.output.unmute();if(this.activePrompt&&typeof this.activePrompt.close==="function"){this.activePrompt.close()}// Close the readline
this.rl.output.end();this.rl.pause();this.rl.close()}}function setupReadlineOptions(opt={}){// Inquirer 8.x:
// opt.skipTTYChecks = opt.skipTTYChecks === undefined ? opt.input !== undefined : opt.skipTTYChecks;
opt.skipTTYChecks=opt.skipTTYChecks===undefined?true:opt.skipTTYChecks;// Default `input` to stdin
const input=opt.input||process.stdin;// Check if prompt is being called in TTY environment
// If it isn't return a failed promise
if(!opt.skipTTYChecks&&!input.isTTY){const nonTtyError=new Error("Prompts can not be meaningfully rendered in non-TTY environments");nonTtyError.isTtyError=true;throw nonTtyError}// Add mute capabilities to the output
const ms=new MuteStream;ms.pipe(opt.output||process.stdout);const output=ms;return _objectSpread(_objectSpread({terminal:true},opt),{},{input,output})}/**
 * Sticky bottom bar user interface
 */class BottomBar extends UI{constructor(opt={}){super(opt);this.log=through(this.writeLog.bind(this));this.bottomBar=opt.bottomBar||"";this.render()}/**
   * Render the prompt to screen
   * @return {BottomBar} self
   */render(){this.write(this.bottomBar);return this}clean(){clearLine(this.rl,this.bottomBar.split("\n").length);return this}/**
   * Update the bottom bar content and rerender
   * @param  {String} bottomBar Bottom bar content
   * @return {BottomBar}           self
   */updateBottomBar(bottomBar){clearLine(this.rl,1);this.rl.output.unmute();this.clean();this.bottomBar=bottomBar;this.render();this.rl.output.mute();return this}/**
   * Write out log data
   * @param {String} data - The log data to be output
   * @return {BottomBar} self
   */writeLog(data){this.rl.output.unmute();this.clean();this.rl.output.write(this.enforceLF(data.toString()));this.render();this.rl.output.mute();return this}/**
   * Make sure line end on a line feed
   * @param  {String} str Input string
   * @return {String}     The input string with a final line feed
   */enforceLF(str){return str.match(/[\r\n]$/)?str:str+"\n"}/**
   * Helper for writing message in Prompt
   * @param {String} message - The message to be output
   */write(message){const msgLines=message.split(/\n/);this.height=msgLines.length;// Write message to screen and setPrompt to control backspace
this.rl.setPrompt(msgLines[msgLines.length-1]);if(this.rl.output.rows===0&&this.rl.output.columns===0){/* When it's a tty through serial port there's no terminal info and the render will malfunction,
         so we need enforce the cursor to locate to the leftmost position for rendering. */left(this.rl,message.length+this.rl.line.length)}this.rl.output.write(message)}}/**
 * Resolve a question property value if it is passed as a function.
 * This method will overwrite the property on the question object with the received value.
 * @param  {Object} question - Question object
 * @param  {String} prop     - Property to fetch name
 * @param  {Object} answers  - Answers object
 * @return {Rx.Observable}   - Observable emitting once value is known
 */const fetchAsyncQuestionProperty=function(question,prop,answers){if(typeof question[prop]!=="function"){return rxjs.of(question)}return rxjs.from(runAsync(question[prop])(answers).then(value=>{question[prop]=value;return question}))};const _={isPlainObject,set,get};/**
 * Base interface class other can inherits from
 */class PromptUI extends UI{constructor(prompts,opt){super(opt);this.prompts=prompts}run(questions,answers){// Keep global reference to the answers
if(_.isPlainObject(answers)){this.answers=_objectSpread({},answers)}else{this.answers={}}// Make sure questions is an array.
if(_.isPlainObject(questions)){// It's either an object of questions or a single question
questions=Object.values(questions).every(v=>_.isPlainObject(v)&&v.name===undefined)?Object.entries(questions).map(([name,question])=>_objectSpread({name},question)):[questions]}// Create an observable, unless we received one as parameter.
// Note: As this is a public interface, we cannot do an instanceof check as we won't
// be using the exact same object in memory.
const obs=Array.isArray(questions)?rxjs.from(questions):questions;this.process=obs.pipe(rxjs.concatMap(this.processQuestion.bind(this)),rxjs.publish()// Creates a hot Observable. It prevents duplicating prompts.
);this.process.connect();return this.process.pipe(rxjs.reduce((answers,answer)=>{_.set(answers,answer.name,answer.answer);return answers},this.answers)).toPromise(Promise).then(this.onCompletion.bind(this),this.onError.bind(this))}/**
   * Once all prompt are over
   */onCompletion(){this.close();return this.answers}onError(error){this.close();return Promise.reject(error)}processQuestion(question){question=_objectSpread({},question);return rxjs.defer(()=>{const obs=rxjs.of(question);return obs.pipe(rxjs.concatMap(this.setDefaultType.bind(this)),rxjs.concatMap(this.filterIfRunnable.bind(this)),rxjs.concatMap(()=>fetchAsyncQuestionProperty(question,"message",this.answers)),rxjs.concatMap(()=>fetchAsyncQuestionProperty(question,"default",this.answers)),rxjs.concatMap(()=>fetchAsyncQuestionProperty(question,"choices",this.answers)),rxjs.concatMap(this.fetchAnswer.bind(this)))})}fetchAnswer(question){const Prompt=this.prompts[question.type];this.activePrompt=new Prompt(question,this.rl,this.answers);return rxjs.defer(()=>rxjs.from(this.activePrompt.run().then(answer=>({name:question.name,answer}))))}setDefaultType(question){// Default type to input
if(!this.prompts[question.type]){question.type="input"}return rxjs.defer(()=>rxjs.of(question))}filterIfRunnable(question){if(question.askAnswered!==true&&_.get(this.answers,question.name)!==undefined){return rxjs.empty()}if(question.when===false){return rxjs.empty()}if(typeof question.when!=="function"){return rxjs.of(question)}const{answers}=this;return rxjs.defer(()=>rxjs.from(runAsync(question.when)(answers).then(shouldRun=>{if(shouldRun){return question}})).pipe(rxjs.filter(val=>val!=null)))}}/**
 * Inquirer.js
 * A collection of common interactive command line user interfaces.
 */ /**
 * Create a new self-contained prompt module.
 */function createPromptModule(opt){const promptModule=function(questions,answers){let uiInstance;try{uiInstance=new PromptUI(promptModule.prompts,opt)}catch(error){return Promise.reject(error)}const promise=uiInstance.run(questions,answers);// Monkey patch the UI on the promise object so
// that it remains publicly accessible.
promise.ui=uiInstance;return promise};promptModule.prompts={};/**
   * Register a prompt type
   * @param {String} name     Prompt type name
   * @param {Function} prompt Prompt constructor
   * @return {inquirer}
   */promptModule.registerPrompt=function(name,prompt){promptModule.prompts[name]=prompt;return this};/**
   * Register the defaults provider prompts
   */promptModule.restoreDefaultPrompts=function(){this.registerPrompt("list",ListPrompt);this.registerPrompt("input",InputPrompt);this.registerPrompt("number",NumberPrompt);this.registerPrompt("confirm",ConfirmPrompt);this.registerPrompt("rawlist",RawListPrompt);this.registerPrompt("expand",ExpandPrompt);this.registerPrompt("checkbox",CheckboxPrompt);this.registerPrompt("password",PasswordPrompt);this.registerPrompt("editor",EditorPrompt)};promptModule.restoreDefaultPrompts();return promptModule}/**
 * Public CLI helper interface
 * @param  {Array|Object|Rx.Observable} questions - Questions settings array
 * @param  {Function} cb - Callback being passed the user answers
 * @return {ui.Prompt}
 */const prompt=createPromptModule();// Expose helper functions on the top level for easiest usage by common users
function registerPrompt(name,newPrompt){prompt.registerPrompt(name,newPrompt)}function restoreDefaultPrompts(){prompt.restoreDefaultPrompts()}const inquirer={prompt,ui:{BottomBar,Prompt:PromptUI},createPromptModule,registerPrompt,restoreDefaultPrompts,Separator};exports.createPromptModule=createPromptModule;exports.default=inquirer;
